#include <complex.h>
#include <math.h>
#include <stdio.h>

double cnorm(double _Complex z)
{
  double x = creal(z);
  double y = cimag(z);
  return x * x + y * y;
}

#define W 640
#define H 360
#define N 1024

#define E0

int main(int argc, char **argv)
{
  (void) argc;
  (void) argv;
#ifdef E0
  double _Complex c0 = -1;
  double r0 = 2;
  int period = 2;
#endif
#ifdef E1
  double _Complex c0 = -1.76;
  double r0 = 0.05;
  int period = 3;
#endif
#ifdef E2
  double _Complex c0 = -1.78;
  double r0 = 0.03;
  int period = 6;
#endif
#ifdef E3
  double _Complex c0 = -1.78;
  double r0 = 0.01;
  int period = 9;
#endif
#ifdef E4
  double _Complex c0 = -0.1 - I * 0.9;
  double r0 = 0.6;
  int period = 3;
#endif
#ifdef E5
  double _Complex c0 = -0.1 - I * 0.9;
  double r0 = 0.6 / 4;
  int period = 6;
#endif
#ifdef E6
  double _Complex c0 = -0.1 - I * 0.925;
  double r0 = 0.01;
  int period = 9;
#endif
#ifdef E7
  double _Complex c0 = -0.1 - I * 0.9;
  double r0 = 0.6 / 16;
  int period = 12;
#endif
  double _Complex nucleus = c0;
  for (int i = 0; i < 30; ++i)
  {
    double _Complex z = 0;
    double _Complex dc = 0;
    for (int j = 0; j < period; ++j)
    {
      dc = 2 * z * dc + 1;
      z = z * z + nucleus;
    }
    nucleus -= z / dc;
  }
  double _Complex z = nucleus;
  double _Complex dz = 1;
  for (int i = 1; i < period; ++i)
  {
    dz = 2 * z * dz;
    z = z * z + nucleus;
  }
  double ER2 = 4;
  double er2 = ER2 / cnorm(dz);
  printf("P6\n%d %d\n255\n", W, H);
  for (int j = 0; j < H; ++j)
  for (int i = 0; i < W; ++i)
  {
    double x = ((i + 0.5) / W - 0.5) * W / H;
    double y = ((j + 0.5) / H - 0.5);
    double _Complex c = c0 + r0 * (x + I * y);
    double _Complex z = 0;
    double _Complex dc = 0;
    double de = -1;
    double DE = -1;
    for (int k = 0; k < N; ++k)
    {
      if (cnorm(z) > er2 && de < 0)
        de = sqrt(cnorm(z)/er2) * log2(2*cnorm(z)/er2) / (cabs(dc) * r0 / H);
      for (int l = 0; l < period; ++l)
      {
        if (cnorm(z) > ER2 && DE < 0)
          DE = sqrt(cnorm(z)/ER2) * log2(2*cnorm(z)/ER2) / (cabs(dc) * r0 / H);
        dc = 2 * z * dc + 1;
        z = z * z + c;
      }
      if (de >= 0 && DE >= 0) break;
    }
    double MU = tanh(fmax(DE, 0));
    double mu = tanh(fmax(fmax(de, DE) * 4 / (period * period), 0));
    double red[3] = { 1, 0, 0 };
    for (int c = 0; c < 3; ++c)
    {
      putchar(255 * (red[c] * (1 - mu) + mu * MU));
    }
  }
  return 0;
}
